$(window).load(function(){

	mason();

	saveButton();

});


var saveButton = function()
{
	if($('.button.save'))
	{

		var spinopts = {
			lines: 8,
			length: 3,
			width: 2,
			radius: 4,
			trail: 60,
			speed: 1.0,
			color: "#9a9a9a"
		}

		var spinner = new Spinner(spinopts).spin();
		$('.button.save .busy').prepend(spinner.el);

		var classNames = ['button save default','button save busy','button save error','button save success'];
		$('.button.save').click(function (e)
		{
			e.preventDefault();
			$(this).toggleClass(function (i, className, b)
			{
				var index = (classNames.indexOf(className) + 1) % classNames.length;
				$(this).removeClass(className);
				return classNames[index];
			});
		});

	}
}

var mason = function()
{
	var container = $('.do-masonry');

	container.isotope({
		itemSelector : 'article'
	});
}


/* these are the centered column overrides from the isotope centered masonry demo */
$.Isotope.prototype._getCenteredMasonryColumns = function()
{
	this.width = this.element.width();

	var parentWidth = this.element.parent().width();

	// i.e. options.masonry && options.masonry.columnWidth
	var colW = this.options.masonry && this.options.masonry.columnWidth ||
	// or use the size of the first item
	this.$filteredAtoms.outerWidth(true) ||
	// if there's no items, use size of container
	parentWidth;

	var cols = Math.floor( parentWidth / colW );
	cols = Math.max( cols, 1 );

	// i.e. this.masonry.cols = ....
	this.masonry.cols = cols;
	// i.e. this.masonry.columnWidth = ...
	this.masonry.columnWidth = colW;
};

$.Isotope.prototype._masonryReset = function()
{
	// layout-specific props
	this.masonry = {};
	// FIXME shouldn't have to call this again
	this._getCenteredMasonryColumns();
	var i = this.masonry.cols;
	this.masonry.colYs = [];
	while (i--)
	{
		this.masonry.colYs.push( 0 );
	}
};

$.Isotope.prototype._masonryResizeChanged = function()
{
	var prevColCount = this.masonry.cols;
	// get updated colCount
	this._getCenteredMasonryColumns();
	return ( this.masonry.cols !== prevColCount );
};

$.Isotope.prototype._masonryGetContainerSize = function()
{
	var unusedCols = 0,
	i = this.masonry.cols;
	// count unused columns
	while ( --i )
	{
		if ( this.masonry.colYs[i] !== 0 )
		{
			break;
		}
		unusedCols++;
	}

	return {
		height : Math.max.apply( Math, this.masonry.colYs ),
		// fit container to columns that have been used;
		width : (this.masonry.cols - unusedCols) * this.masonry.columnWidth
	};
};

